"use strict";
/**
 * Copyright 2020 Valentin Draganescu
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var metadata_storage_1 = require("../../metadata/metadata-storage");
exports.DocProperty = function (props) {
    return function (target, propertyKey) {
        var metadata = metadata_storage_1.getMetadataStorage();
        if (!metadata.entities[target.constructor.name]) {
            metadata.entities[target.constructor.name] = {};
        }
        if (props) {
            metadata.entities[target.constructor.name][propertyKey] = props;
        }
    };
};
exports.InheritedDoc = function () {
    return function (target) {
        var protoName = Object.getPrototypeOf(target).name;
        if (protoName !== "Object") {
            var metadata = metadata_storage_1.getMetadataStorage();
            if (!metadata.entities[target.name]) {
                metadata.entities[target.name] = {};
            }
            if (metadata.entities[protoName]) {
                metadata.entities[target.name] = __assign(__assign({}, metadata.entities[protoName]), metadata.entities[target.name]);
            }
        }
    };
};
//# sourceMappingURL=doc.js.map